--[[

	Quest Completist - qcLogger.lua
	Written by: Alistair Maxwell
	Last Updated: 21/11/2010

--]]

qcLoggerData = {}

function qcGetQuestNPCData() -- Returns NPC GUID, NPC ID and NPC Name --

local qcNPCGUID
local qcNPCID
local qcNPCName

	qcNPCGUID = UnitGUID("target")
	qcNPCName = UnitName("target")

	if (qcNPCGUID == nil) then
		if (qcNPCName == nil) or (qcNPCName == "") then
			return nil, nil, nil
		else
			return nil, nil, qcNPCName
		end
	else
		qcNPCID = tonumber(strsub(qcNPCGUID, 7, 10), 16)
		if (qcNPCID == nil) or (qcNPCID == "") then
			if (qcNPCName == nil) or (qcNPCName == "") then
				return nil, nil, nil
			else
				return nil, nil, qcNPCName
			end
		end
		if (qcNPCName == nil) or (qcNPCName == "") then
			return nil, nil, nil
		end
	end

	return qcNPCGUID, qcNPCID, qcNPCName

end

function qcQuestDetail(qcAccept) -- Saves quest information to file for later use --

if (qcAccept == true) then

local qcQuestID
local qcQuestTitle
local qcPlayerXPos
local qcPlayerYPos
local qcNPCGUID
local qcNPCID
local qcNPCName
local qcQuestCategory

	qcQuestID = GetQuestID()
	qcNPCGUID, qcNPCID, qcNPCName = qcGetQuestNPCData()
	qcQuestTitle = GetTitleText()
	qcQuestCategory = qcGetQuestCategory(qcQuestID)

	if (qcLoggerData[qcQuestID] == nil) then
		qcLoggerData[qcQuestID] = {}
	end
	if (qcLoggerData[qcQuestID]["A"] == nil) then
		qcLoggerData[qcQuestID]["A"] = {}
	end

	qcLoggerData[qcQuestID]["PC"] = playerEnglishClass
	qcLoggerData[qcQuestID]["PF"] = playerEnglishFaction
	qcLoggerData[qcQuestID]["A"]["T"] = qcQuestTitle
	qcLoggerData[qcQuestID]["A"]["C"] = qcGetQuestCategory(qcQuestID)
	qcLoggerData[qcQuestID]["A"]["NPCGUID"] = qcNPCGUID
	qcLoggerData[qcQuestID]["A"]["NPCID"] = qcNPCID
	qcLoggerData[qcQuestID]["A"]["NPCN"] = qcNPCName
	qcLoggerData[qcQuestID]["A"]["Z"] = GetRealZoneText()

	qcPlayerXPos, qcPlayerYPos = GetPlayerMapPosition("player")
	qcLoggerData[qcQuestID]["A"]["PX"] = (qcPlayerXPos*100)
	qcLoggerData[qcQuestID]["A"]["PY"] = (qcPlayerYPos*100)

elseif (qcAccept == false) then -- Treat this as a quest being handed in or completed, not accepted --

local qcQuestID
local qcQuestTitle
local qcPlayerXPos
local qcPlayerYPos
local qcNPCGUID
local qcNPCID
local qcNPCName
local qcQuestCategory

	qcQuestID = GetQuestID()
	qcNPCGUID, qcNPCID, qcNPCName = qcGetQuestNPCData()
	qcQuestTitle = GetTitleText()
	qcQuestCategory = qcGetQuestCategory(qcQuestID)

	if (qcLoggerData[qcQuestID] == nil) then
		qcLoggerData[qcQuestID] = {}
	end
	if (qcLoggerData[qcQuestID]["C"] == nil) then
		qcLoggerData[qcQuestID]["C"] = {}
	end

	qcLoggerData[qcQuestID]["PC"] = playerEnglishClass
	qcLoggerData[qcQuestID]["PF"] = playerEnglishFaction
	qcLoggerData[qcQuestID]["C"]["T"] = qcQuestTitle
	qcLoggerData[qcQuestID]["C"]["C"] = qcGetQuestCategory(qcQuestID)
	qcLoggerData[qcQuestID]["C"]["NPCGUID"] = qcNPCGUID
	qcLoggerData[qcQuestID]["C"]["NPCID"] = qcNPCID
	qcLoggerData[qcQuestID]["C"]["NPCN"] = qcNPCName
	qcLoggerData[qcQuestID]["C"]["Z"] = GetRealZoneText()

	qcPlayerXPos, qcPlayerYPos = GetPlayerMapPosition("player")
	qcLoggerData[qcQuestID]["C"]["PX"] = (qcPlayerXPos*100)
	qcLoggerData[qcQuestID]["C"]["PY"] = (qcPlayerYPos*100)

end

end

function qcGetQuestCategory(qcQuestID) -- Returns the category of a quest from the quest log --

local _S
local qcIsHeader
local qcHeader

local qcQuestIDIndex = GetQuestLogIndexByID(qcQuestID)

	if (qcQuestIDIndex == 0) then
		return nil
	end

	while (qcQuestIDIndex >= 1) do
		qcHeader, _S, _S, _S, qcIsHeader, _S, _S, _S, _S = GetQuestLogTitle(qcQuestIDIndex)
		if (qcIsHeader == 1) then return qcHeader end
		qcQuestIDIndex = qcQuestIDIndex - 1
	end

	return nil

end